# $Revision: 1.56.2.8 $, $Date: 2004/09/01 08:07:18 $
#
# Conditional build:
%bcond_without	dist_kernel	# without distribution kernel
%bcond_without	smp		# without smp packages
%bcond_without	up		# without up packages
%bcond_with	kernel		# with kernel packages
%bcond_with	verbose		# verbose build (V=1)
%bcond_with	tls		# install libraries with tls support
#
%define		_nv_ver		1.0
%define		_nv_rel		6111
%define		_min_x11	4.0.1
%define		_rel		4
#
Summary:	Linux Drivers for nVidia TNT/TNT2/GeForce/Quadro Chips
Summary(pl):	Sterowniki do kart graficznych nVidia TNT/TNT2/GeForce/Quadro
Name:		XFree86-driver-nvidia
Version:	%{_nv_ver}.%{_nv_rel}
Release:	%{_rel}
License:	nVidia Binary
Vendor:		nVidia Corp.
Group:		X11/XFree86
Source0:	http://download.nvidia.com/XFree86/Linux-x86/%{_nv_ver}-%{_nv_rel}/NVIDIA-Linux-x86-%{_nv_ver}-%{_nv_rel}-pkg1.run
# Source0-md5:	51e83be46f83c52102ccb8995b54f4e2
Source1:	http://download.nvidia.com/XFree86/Linux-x86_64/%{_nv_ver}-%{_nv_rel}/NVIDIA-Linux-x86_64-%{_nv_ver}-%{_nv_rel}-pkg2.run
# Source1-md5:	6c7b0c8b3ce5c34186e0c80042e6d046
Patch0:		%{name}-gcc34.patch
URL:		http://www.nvidia.com/object/linux.html
BuildConflicts:	XFree86-nvidia
BuildRequires:	grep
%{?with_dist_kernel:BuildRequires:	kernel-module-build >= 2.6.7}
BuildRequires:	%{kgcc_package}
BuildRequires:	rpmbuild(macros) >= 1.153
BuildRequires:	sed >= 4.0
BuildRequires:	textutils
BuildRequires:	XFree86-devel >= %{_min_x11}
Requires:	XFree86-Xserver
Requires:	XFree86-libs >= %{_min_x11}
Requires:	XFree86-modules >= %{_min_x11}
%{?with_tls:Requires:	glibc(tls)}
Provides:	X11-OpenGL-core
Provides:	X11-OpenGL-libGL
Provides:	XFree86-OpenGL-core
Provides:	XFree86-OpenGL-libGL
Obsoletes:	Mesa
Obsoletes:	X11-OpenGL-core
Obsoletes:	X11-OpenGL-libGL
Obsoletes:	XFree86-OpenGL-core
Obsoletes:	XFree86-OpenGL-libGL
Obsoletes:	X11-driver-nvidia
Obsoletes:	XFree86-nvidia
Conflicts:	XFree86-OpenGL-devel <= 4.2.0-3
ExclusiveArch:	%{ix86} amd64
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_noautoreqdep	libGL.so.1 libGLcore.so.1
%define		_prefix		/usr/X11R6
%ifarch amd64
%define		_libdir32	%{_prefix}/lib
%endif

%description
This driver set adds improved 2D functionality to the XFree86 4.0 X
server as well as high performance OpenGL acceleration, AGP support,
support for most flat panels, and 2D multiple monitor support.

Hardware: nVidia TNT, TNT2, GeForce, or Quadro based graphics
accelerator. The nVidia NV1 and RIVA 128/128ZX chips are supported in
the base XFree86 4.0 install and are not supported by this driver set.

Software: Linux kernel >= 2.2.12, XFree86 >= 4.0.

%description -l pl
Usprawnione sterowniki dla kart graficznych nVidia do serwera XFree86
4.0, dajce wysokowydajn akceleracj OpenGL, obsug AGP i wielu
monitorw 2D.

Obsuguj karty nVidia TNT/TNT2/GeForce/Quadro do serwera XFree86 4.0;
Karty nVidia NV1 i Riva 128/128ZX s obsugiwane przez sterownik nv z
pakietw XFree86 - NIE s obsugiwane przez ten pakiet.

%package devel
Summary:	OpenGL for X11R6 development (only gl?.h)
Summary(pl):	Pliki nagwkowe OpenGL dla systemu X11R6 (tylko gl?.h)
Group:		X11/Development/Libraries
Requires:	%{name} = %{version}-%{release}
Provides:	OpenGL-devel-base
Obsoletes:	OpenGL-devel-base
Obsoletes:	XFree86-driver-nvidia-devel
Conflicts:	XFree86-OpenGL-devel < 4.3.99.902-0.3

%description devel
Base headers (only gl?.h) for OpenGL for X11R6 for nvidia drivers.

%description devel -l pl
Podstawowe pliki nagwkowe (tylko gl?.h) OpenGL dla systemu X11R6 dla
sterownikw nvidii.

%package progs
Summary:	Tools for advanced control of nVidia graphic cards
Summary(pl):	Narzdzia do zarzdzania kartami graficznymi nVidia
Group:		Applications/System
Obsoletes:	X11-driver-nvidia-progs
Requires:	%{name} = %{version}-%{release}

%description progs
Tools for advanced control of nVidia graphic cards.

%description progs -l pl
Narzdzia do zarzdzania kartami graficznymi nVidia.

%package -n kernel-video-nvidia
Summary:	nVidia kernel module for nVidia Architecture support
Summary(de):	Das nVidia-Kern-Modul fr die nVidia-Architektur-Untersttzung
Summary(pl):	Modu jdra dla obsugi kart graficznych nVidia
Version:	%{_nv_ver}.%{_nv_rel}
Release:	%{_rel}@%{_kernel_ver_str}
Group:		Base/Kernel
PreReq:		modutils >= 2.3.18-2
Requires(post,postun):	/sbin/depmod
Requires:	dev >= 2.7.7-10
%{?with_dist_kernel:%requires_releq_kernel_up}
Provides:	X11-driver-nvidia(kernel)
Obsoletes:	XFree86-nvidia-kernel

%description -n kernel-video-nvidia
nVidia Architecture support for Linux kernel.

%description -n kernel-video-nvidia -l de
Die nVidia-Architektur-Untersttzung fr den Linux-Kern.

%description -n kernel-video-nvidia -l pl
Obsuga architektury nVidia dla jdra Linuksa. Pakiet wymagany przez
sterownik nVidii dla XFree86 4.

%package -n kernel-smp-video-nvidia
Summary:	nVidia kernel module for nVidia Architecture support
Summary(de):	Das nVidia-Kern-Modul fr die nVidia-Architektur-Untersttzung
Summary(pl):	Modu jdra dla obsugi kart graficznych nVidia
Release:	%{_rel}@%{_kernel_ver_str}
Group:		Base/Kernel
PreReq:		modutils >= 2.3.18-2
Requires(post,postun):	/sbin/depmod
Requires:	dev >= 2.7.7-10
%{?with_dist_kernel:%requires_releq_kernel_smp}
Provides:	X11-driver-nvidia(kernel)
Obsoletes:	XFree86-nvidia-kernel

%description -n kernel-smp-video-nvidia
nVidia Architecture support for Linux kernel SMP.

%description -n kernel-smp-video-nvidia -l de
Die nVidia-Architektur-Untersttzung fr den Linux-Kern SMP.

%description -n kernel-smp-video-nvidia -l pl
Obsuga architektury nVidia dla jdra Linuksa SMP. Pakiet wymagany
przez sterownik nVidii dla XFree86 4.

%prep
cd %{_builddir}
rm -rf NVIDIA-Linux-x86*-%{_nv_ver}-%{_nv_rel}-pkg*
%ifarch %{ix86}
/bin/sh %{SOURCE0} --extract-only
%setup -qDT -n NVIDIA-Linux-x86-%{_nv_ver}-%{_nv_rel}-pkg1
%else
/bin/sh %{SOURCE1} --extract-only
%setup -qDT -n NVIDIA-Linux-x86_64-%{_nv_ver}-%{_nv_rel}-pkg2
%endif
%patch0 -p1
sed -i 's:-Wpointer-arith::' usr/src/nv/Makefile.kbuild

%build
%if %{with kernel}
cd usr/src/nv/
ln -sf Makefile.kbuild Makefile
for cfg in %{?with_dist_kernel:%{?with_smp:smp} %{?with_up:up}}%{!?with_dist_kernel:nondist}; do
    if [ ! -r "%{_kernelsrcdir}/config-$cfg" ]; then
        exit 1
    fi
    rm -rf include
    install -d include/{linux,config}
    ln -sf %{_kernelsrcdir}/config-$cfg .config
    ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h include/linux/autoconf.h
    ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch} include/asm
    touch include/config/MARKER
    %{__make} -C %{_kernelsrcdir} clean \
	RCS_FIND_IGNORE="-name '*.ko' -o -name nv-kernel.o -o" \
        M=$PWD O=$PWD \
        %{?with_verbose:V=1}
    %{__make} -C %{_kernelsrcdir} modules \
	CC="%{__cc}" CPP="%{__cpp}" \
        M=$PWD O=$PWD \
        %{?with_verbose:V=1}
    mv nvidia.ko nvidia-$cfg.ko
done
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_libdir}/modules/{drivers,extensions} \
	$RPM_BUILD_ROOT{/usr/include/GL,/usr/%{_lib},%{_bindir}}

ln -sf $RPM_BUILD_ROOT%{_libdir} $RPM_BUILD_ROOT%{_prefix}/../lib

install usr/bin/nvidia-settings $RPM_BUILD_ROOT%{_bindir}
install usr/lib%{?with_tls:/tls}/libnvidia-tls.so.%{version} $RPM_BUILD_ROOT%{_libdir}
install usr/lib/libGL{,core}.so.%{version} $RPM_BUILD_ROOT%{_libdir}
install usr/X11R6/lib/modules/extensions/libglx.so.%{version} \
	$RPM_BUILD_ROOT%{_libdir}/modules/extensions
%ifarch amd64
# support for running 32-bit OpenGL applications on 64-bit AMD64 Linux installations
#install -d $RPM_BUILD_ROOT%{_libdir32}
#install usr/lib32%{?with_tls:/tls}/libnvidia-tls.so.%{version} $RPM_BUILD_ROOT%{_libdir32}
#install usr/lib32/libGL{,core}.so.%{version} $RPM_BUILD_ROOT%{_libdir32}
%endif

install usr/X11R6/lib/modules/drivers/nvidia_drv.o $RPM_BUILD_ROOT%{_libdir}/modules/drivers
install usr/X11R6/lib/libXvMCNVIDIA.* $RPM_BUILD_ROOT%{_libdir}
install usr/include/GL/*.h	$RPM_BUILD_ROOT/usr/include/GL
#install usr/bin/nvidia-settings $RPM_BUILD_ROOT%{_bindir}

ln -sf libGL.so.1 $RPM_BUILD_ROOT%{_libdir}/libGL.so
ln -sf libglx.so.%{version} $RPM_BUILD_ROOT%{_libdir}/modules/extensions/libglx.so
ln -sf libXvMCNVIDIA.so.%{version} $RPM_BUILD_ROOT%{_libdir}/libXvMCNVIDIA.so

# OpenGL ABI for Linux compatibility
ln -sf %{_libdir}/libGL.so.1 $RPM_BUILD_ROOT/usr/%{_lib}/libGL.so.1
ln -sf %{_libdir}/libGL.so $RPM_BUILD_ROOT/usr/%{_lib}/libGL.so

%if %{with kernel}
cd usr/src/nv/
install -d $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}{,smp}/misc
%if %{with dist_kernel}
%if %{with up}
install nvidia-up.ko \
	$RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}/misc/nvidia.ko
%endif
%if %{with smp}
install nvidia-smp.ko \
	$RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}smp/misc/nvidia.ko
%endif
%else
install nvidia-%{?with_dist_kernel:up}%{!?with_dist_kernel:nondist}.ko \
	$RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}/misc/nvidia.ko
%endif
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
cat << EOF

 *******************************************************
 *                                                     *
 *  NOTE:                                              *
 *  You must install:                                  *
 *  kernel(24)(-smp)-video-nvidia-%{version}             *
 *  for this driver to work                            *
 *                                                     *
 *******************************************************

EOF

%postun	-p /sbin/ldconfig

%post	-n kernel-video-nvidia
%depmod %{_kernel_ver}

%postun	-n kernel-video-nvidia
%depmod %{_kernel_ver}

%post	-n kernel-smp-video-nvidia
%depmod %{_kernel_ver}smp

%postun	-n kernel-smp-video-nvidia
%depmod %{_kernel_ver}smp

%files
%defattr(644,root,root,755)
%doc LICENSE
%doc usr/share/doc/{README,NVIDIA_Changelog,XF86Config.sample}
%lang(de) %doc usr/share/doc/README.DE
%attr(755,root,root) %{_libdir}/libGL.so.*.*
%attr(755,root,root) %{_libdir}/libGL.so
%attr(755,root,root) %{_libdir}/libGLcore.so.*.*
%attr(755,root,root) %{_libdir}/libXvMCNVIDIA.so.*.*
%attr(755,root,root) %{_libdir}/libnvidia-tls.so.*.*.*
%ifarch amd64
# support for running 32-bit OpenGL applications on 64-bit AMD64 Linux installations
#dir %{_libdir32}
#attr(755,root,root) %{_libdir32}/libGL.so.*.*
#attr(755,root,root) %{_libdir32}/libGLcore.so.*.*
#attr(755,root,root) %{_libdir32}/libXvMCNVIDIA.so.*.*
#attr(755,root,root) %{_libdir32}/libnvidia-tls.so.*.*.*
%endif
%attr(755,root,root) /usr/%{_lib}/libGL.so.1
%attr(755,root,root) /usr/%{_lib}/libGL.so
%attr(755,root,root) %{_libdir}/modules/extensions/libglx.so*
%attr(755,root,root) %{_libdir}/modules/drivers/nvidia_drv.o

%if %{with kernel}
%if %{with up} || %{without dist_kernel}
%files -n kernel-video-nvidia
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}/misc/*.ko*
%endif

%if %{with smp} && %{with dist_kernel}
%files -n kernel-smp-video-nvidia
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}smp/misc/*.ko*
%endif
%endif

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libXvMCNVIDIA.so
/usr/include/GL/*.h
# -static
%{_libdir}/libXvMCNVIDIA.a

%files progs
%defattr(755,root,root,755)
%{_bindir}/nvidia-settings

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: XFree86-driver-nvidia.spec,v $
Revision 1.56.2.8  2004/09/01 08:07:18  wiget
- --without up bcond
- release 4

Revision 1.56.2.7  2004/08/21 13:51:19  havner
- fixed banner

Revision 1.56.2.6  2004/08/17 18:36:57  havner
- without kernel modules by default
- rel 2

Revision 1.56.2.5  2004/08/08 17:24:09  havner
- change group for progs subpackage

Revision 1.56.2.4  2004/08/05 20:53:38  havner
- update to 6111

Revision 1.56.2.3  2004/07/29 22:14:59  havner
- removed senseless provides
- obsolete for progs package
- rel 2

Revision 1.56.2.2  2004/07/29 21:49:11  havner
- bcond without kernel

Revision 1.56.2.1  2004/07/29 21:33:05  havner
- XFree86 version for AC

Revision 1.12  2004/07/23 13:04:56  pluto
- scripts fixed (thx Micha ukaszek <prism#hornet#eu#org>).

Revision 1.11  2004/07/21 17:48:20  havner
- removed R: kernel-video-nvidia
- added post message about this
- rel 2

Revision 1.10  2004/07/04 20:42:32  qboosh
- libdir32 is just prefix/lib on amd64

Revision 1.9  2004/07/04 20:40:02  pluto
- amd64 parts...

Revision 1.8  2004/07/04 01:19:24  pluto
- `-Wpointer-arith' killed.

Revision 1.7  2004/07/03 18:36:56  pluto
- make clean/modules separated for parallel build.
- log fixed.

Revision 1.6  2004/07/03 16:54:24  pluto
- updated to 1.0-6106.

Revision 1.5  2004/07/01 17:05:46  qboosh
- fixed _noautoreqdep (it must be SONAME, not filename)

Revision 1.4  2004/07/01 15:49:04  havner
- provides/obsoletes...

Revision 1.3  2004/07/01 15:33:05  havner
- define _min_x11
- cosmetics

Revision 1.2  2004/06/30 09:53:22  pluto
- R:,O:,P: fixed (I hope).

Revision 1.1  2004/06/30 07:36:25  pluto
- renamed, NFY...

Revision 1.56  2004/06/02 18:25:09  pluto
- BR: fixed.

Revision 1.55  2004/05/29 11:16:30  pluto
- minor build fixes.
- release 3.

Revision 1.54  2004/05/21 11:36:02  pluto
- 2.6.6 complaint.

Revision 1.53  2004/04/17 14:52:21  saq
- typo

Revision 1.52  2004/04/08 17:17:42  pluto
- R: fixed (s/nvidia-kernel-module/XFree86-nvidia-kernel/)

Revision 1.51  2004/04/08 10:51:52  pluto
- merged with kernel-video-nvidia.
- %%build complaint with 2.6.x.

Revision 1.50  2004/04/03 22:33:26  gotar
- s/glibc-tls/glibc(tls)/

Revision 1.49  2004/04/03 12:42:33  gotar
- builded with tls support requires this feature in glibc

Revision 1.48  2004/02/10 15:54:22  qboosh
- Linux OpenGL ABI compliance; moved static lib from base to -devel
- release 2

Revision 1.47  2004/01/28 21:09:59  grzegol
- updated to 1.0-5336

Revision 1.46  2004/01/11 13:16:37  grzegol
- added with_tls bcond (for glibc built with tls support)
- rel. 2

Revision 1.45  2003/12/28 18:13:45  adgor
- Fixed source url
- Standarized macros

Revision 1.44  2003/12/28 17:45:37  adgor
- Updated to 1.0.5328
- Settings tool is unavailable in this version
- Fixed "Conflicts" entry for devel subpkg

Revision 1.43  2003/12/17 20:12:34  grzegol
- updated to 1.0-4620 and added -progs subpackage (by Wieslaw Kierbedz
  <WieslawKierbedz@farba.eu.org>

Revision 1.42  2003/11/09 23:06:31  gotar
- Obsoletes: XFree86-OpenGL-libGL

Revision 1.41  2003/08/27 00:16:31  gotar
- fixed changelog trailer

Revision 1.40  2003/08/02 10:43:33  grzegol
- added URL
- cosmetics

Revision 1.39  2003/07/28 22:50:26  grzegol
- updated to 1.0-4496
- cosmetics

Revision 1.38  2003/07/06 23:27:15  blues
- many small fixes, mostly inpired by kloczek

Revision 1.37  2003/05/26 16:24:19  malekith
- massive attack: adding Source-md5

Revision 1.36  2003/05/25 05:45:22  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.35  2003/04/25 11:59:45  wiget
- updated to 1.0-4363

Revision 1.34  2003/04/08 19:04:30  djurban
- added OpenGL-devel-base

Revision 1.33  2003/04/01 19:39:53  wolf
- 4349
- XFree driver and kernel module now in one package
- moved libGL.so to /usr/lib
- you want kernel module, you do it

Revision 1.32  2002/12/12 14:37:53  baggins
- updated to 1.0-4191

Revision 1.31  2002/11/30 23:35:51  gotar
- s/appnkldir/applnkdir/ (what for these defines are?)

Revision 1.30  2002/09/13 09:21:17  wiget
- 1.0.3123

Revision 1.29  2002/05/31 20:52:23  filon
- added missing files (docs and libXvNVIDIA.a)
- new %%doc

Revision 1.28  2002/05/29 07:40:32  wiget
revert last change and add Conflicts: XFree86-OpenGL-devel <= 4.2.0-3

Revision 1.26  2002/05/23 16:35:13  wiget
2960

Revision 1.25  2002/05/17 09:07:18  wiget
move libGL.so to main package, release 2

Revision 1.24  2002/04/08 16:50:23  wiget
start update to 2880

Revision 1.23  2002/03/11 01:50:59  jack
Updated to 2802

Revision 1.22  2002/02/22 23:28:39  kloczek
- removed all Group fields translations (oure rpm now can handle translating
  Group field using gettext).

Revision 1.21  2002/01/18 02:12:15  kloczek
perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.20  2002/01/03 23:03:20  gotar
- s/NVIDIA/nVidia/

Revision 1.19  2001/12/28 17:15:53  gotar
- changes in descriptions.

Revision 1.18  2001/12/18 19:51:17  gotar
- according to 2.1.2 Linux Exception of NVIDIA Software License it's
  legal to copy and redistibute files... I think so...

Revision 1.17  2001/12/13 08:42:51  gotar
- fixed building source packages w/o illegal sources.

Revision 1.16  2001/12/10 02:20:50  gotar
- made not to get sources and build without license agreement,
- release 2.

Revision 1.15  2001/11/29 15:34:53  misiek
- updated to 2313

Revision 1.14  2001/11/22 10:14:55  qboosh
- s/Copyright/License/; improved pl description

Revision 1.13  2001/11/14 23:39:31  misiek
- added Obsoletes: XFree86-OpenGL-core

Revision 1.12  2001/10/21 23:42:41  undefine
- adapterized to new kernel's driver name.

Revision 1.11  2001/09/20 08:02:09  filon
- really fixed source0

Revision 1.10  2001/09/20 07:53:58  filon
- updated to 1.0-1541
- new source adress

Revision 1.9  2001/09/05 09:25:11  filon
- ver 1.0-1512

Revision 1.8  2001/07/18 03:20:04  kloczek
- spec adapterized.

Revision 1.7  2001/06/02 14:51:05  klakier
- typo

Revision 1.6  2001/05/18 14:37:58  misiek
- updated to 1.0 1251

Revision 1.5  2001/04/29 13:21:34  mkochano
- Updated to 0.9.769.

Revision 1.4  2001/04/10 21:06:11  saq
- s/MVidia/NVidia
- adapterized

Revision 1.3  2001/03/14 19:14:20  mkochano
- Updated to 0.9.767.

Revision 1.2  2001/02/15 23:01:12  kloczek
- added XFree86-Xserver to Requires.

Revision 1.1  2001/02/15 22:50:18  misiek
renamed

Revision 1.8  2001/01/19 07:44:23  mkochano
- Updated to 0.9.6.

Revision 1.7  2000/12/24 17:08:35  waszi
- typo

Revision 1.6  2000/10/10 18:51:29  saq
- Requires: %{name}-kernel

Revision 1.5  2000/09/12 15:53:12  kloczek
- adapterized.

Revision 1.4  2000/09/12 13:56:38  baggins
- updated to 0.95

Revision 1.3  2000/07/18 13:29:45  baggins
- updated to 0.9-4 and XFree 4.0.1

Revision 1.2  2000/07/11 13:30:54  baggins
- release 2
- removed Mesa sources and libGLU (now in XFree86-OpenGL-libs)

Revision 1.1  2000/06/26 17:32:05  baggins
- new, written from scratch
